/** Update component component properties */
try{
    // Init component \see data in component html
    function onInitComponent(data){
        //console.log("[onInitComponent][" + data.source() + "][" + data + "]");
        onUpdate_mainframe(data);
        onGuiInit_vivaldigiovefree(data);
        return true;
    }
    // compones-mainframe.html callback
    function onGuiChangeGateway(sender,gateway,data) {
        //console.log("[onGuiChangeGateway][" + sender.source + "][" + gateway.getProtocol() + "][" + data + "]");
        return onUpdate_protocol(gateway.getProtocol(), data);
        return true;
    }


    /** On Update Component Function (Required)
     * Update component when some change has occured
     */
    function onUpdateComponent(data){
        itemsDropDownSelector       (setDropDownParam,$(".defaultparam"),
        {
            label:"Value type:",
            uid:"datatype",
            options:[
                "Text",
                "Number",
                "Energy (Wh)",
                "Energy (kWh)",
                "Energy (MWh)",
                "Energy (GWh)",
                "Power (W)",
                "Power (kW)",
                "Power (MW)",
                "Reactive energy (VARh)",
                "Reactive energy (kVARh)",
                "Reactive power (VAR)",
                "Reactive power (kVAR)",
                "Power factor (cosφ)",
                "Temperature °C",
                "Temperature °F",
                "Luminance",
                "Relative Humidity",
                "Atmospheric Pressure",
                "Solar Radiation",
                "Rain Rate",
                "Weight",
                "Voltage",
                "Current",
                "CO2 Level",
                "Air Flow"
            ],
            values:[
                "Text",
                "Number",
                "Energy (Wh)",
                "Energy (kWh)",
                "Energy (MWh)",
                "Energy (GWh)",
                "Power (W)",
                "Power (kW)",
                "Power (MW)",
                "Reactive energy (VARh)",
                "Reactive energy (kVARh)",
                "Reactive power (VAR)",
                "Reactive power (kVAR)",

                "Power factor",
                "Temperature °C",
                "Temperature °F",
                "Luminance",
                "Relative Humidity",
                "Atmospheric Pressure",
                "Solar Radiation",
                "Rain Rate",
                "Weight",
                "Voltage",
                "Current",
                "CO2 Level",
                "Air Flow"
            ],
            default: "Number"

        });

        paramCheckBox               ($(".defaultparam"),{checkboxChangeCallBack: updateCustomData ,label:"Enable data recording",uid:"datarecording",defalut:"false"});

        var protocolUpdated = onUpdate_protocol(data.protocol(), data);

        var oComponent = data.node();
        //Check
        if(! (oComponent instanceof Component) ){
            throw "oComponent is not a Component instance";
            return false;
        }

        $("[eve-manager-id='UID']").text(oComponent.UId);
        $("[eve-manager-id='type']").text(oComponent.type);

        //Set name
        var $Elem = $componentProperties.find("[eve-manager-id='name']");
        $Elem.val(oComponent.getParamVal("name"));
        
        //Set html name
        $Elem = $("#"+ oComponent.id +" .components-text");
        $Elem.text(oComponent.getParamVal("name"));

        //Build gateways
        $Elem = $componentProperties.find("[eve-manager-id='gateway']");
        $.publish("/view/gateways/refresh/dependencies");

        //Set gateways
        var strProtocol;
        $Elem = $componentProperties.find("[eve-manager-id='gateway'] option");
        $componentProperties.find(".protocols").hide();                                             //Hide all protocols
        for(var i = 0; i < $Elem.length; ++i){
            var $currElem = $($Elem[i]);
            var oNode = $currElem.data("eveManagerNode");

            //Find gateway
            if(oNode === oComponent.getParamVal("gateway")){
                
                $currElem.prop("selected",true);                                                    //Select gateway
                if(oNode == undefined){ break; }                                                    //If none gateway is selected break for cycle
                
                var oGateway = oNode.getData();                                                     //Get node data (gateway)
                
                strProtocol = oGateway.getProtocol();                                               //Get protocol id
                $componentProperties.find("[eve-manager-protocol='"+ strProtocol +"']").show();     //Show protocol view
                break;
            }
        }

        //Set enable history
        $Elem = $componentProperties.find("[eve-manager-id='history']");
        $Elem.prop("checked",oComponent.getParamVal("history"));
        
        //Set enable savelastvalue
        $Elem = $componentProperties.find("[eve-manager-id='savelastvalue']");
        $Elem.prop("checked",oComponent.getParamVal("savelastvalue"));
        
        //Set enable cache
        $Elem = $componentProperties.find("[eve-manager-id='cache']");
        $Elem.prop("checked",oComponent.getParamVal("cache"));

        //Set user visibility
        $Elem = $componentProperties.find("[eve-manager-id='uservisibility']");
        $Elem.prop("checked",oComponent.getParamVal("uservisibility"));


        //Set customData
        $Elem = $componentProperties.find("[eve-manager-id='customData']");
       // console.log(oComponent.getParamVal("customData"));
        $Elem.prop("value",oComponent.getParamVal("customData"));

        //Set tag
        refreshTags(data);

        refreshTextFormat(); // aggiorna i dati in modo che EVE remote possa scalare i dati

        //Set icon
        $Elem = $componentProperties.find("[eve-manager-id='icons']");
        var aIcons = oComponent.getParamVal("icons");
        $.publish("/view/components/"+ oComponent.id +"/refresh/parameter",[oComponent,"icons"]);

        //Set Slider Values
        refreshValues(oComponent.getParamVal("values"));

        //Set KNX feedback address
        $Elem = $componentProperties.find("[eve-manager-id='knx/feedback-address']");
        var aValue = oComponent.getParamVal("knx/feedback-address").split("/");
        for (var i = 0; i < aValue.length; ++i) {
            $Elem[i].value = aValue[i];
        }

        $Elem = $componentProperties.find("[eve-manager-id='knx/virtual-feedback']");
        $Elem.prop("checked", oComponent.getParamVal("knx/virtual-feedback"));

        $Elem = data.$properties().find("[eve-manager-id='knx/read-init']");
        $Elem.prop("checked", data.node().getParamVal("knx/read-init"));

        //Load and fill KNX data point type (DPT) from "./declarations/DataPointType.json"
        $Elem = $("#componentproperties [eve-manager-id='knx/DPT']");
        $Elem.empty();
        var dpt = oComponent.getParamVal("knx/DPT");

        //Fill combo box

        //Empty data point type item
        var $option = $("<option></option>");
        $option.val("none");
        $option.text("none");
        if (dpt == "none") {
            $option.prop("selected", true);
        }
        $Elem.append($option);

        for (var i = 0; i < application.DPT.length; ++i) {
            var $option = $("<option></option>");
            var strValue = application.DPT[i].main + "." + application.DPT[i].sub;
            $option.val(strValue);
            //console.log(strValue);
            //console.log(application.DPT[i].name);
            $option.text(strValue + " - " + application.DPT[i].name);
            $Elem.append($option);

            //Select
            if (dpt == strValue) {
                $option.prop("selected", true);
            }
            //console.log($Elem.length);
        }

        $Elem = $componentProperties.find("[eve-manager-id='knx/raw-value']");
        $Elem.prop("checked", oComponent.getParamVal("knx/raw-value"));

        $Elem = $componentProperties.find("[eve-manager-id='knx/raw-multiplier']");
        $Elem.val(oComponent.getParamVal("knx/raw-multiplier"));

        $Elem = $componentProperties.find("[eve-manager-id='knx/raw-digits']");
        $Elem.val(oComponent.getParamVal("knx/raw-digits"));

        $Elem = $componentProperties.find("[eve-manager-id='knx/raw-suffix']");
        $Elem.val(oComponent.getParamVal("knx/raw-suffix"));


        if(!protocolUpdated) {
            /** VIMAR By Me */
            {
                var json = blr.declarations.vimar.devices;
                $dropDown = $componentProperties.find("[eve-manager-id='vimar/device-pid']");
                var $none = $("<option value='none' dictionary='None'>" + _D("None") + "</option>");
                $dropDown.append($none);

                //Parsing Vimar By Me Devices
                for (var i = 0; i < json.length; ++i) {
                    var $option = $("<option></option>");

                    //Check if is for Combo
                    if (json[i].componentsType.indexOf("info") != -1) {
                        $option.text(json[i].itemCodes.toString() + " - " + _D(json[i].label));
                        $option.attr("title", _D(json[i].label));
                        $option.val(json[i].pid);
                        $option.data("VimarByMe", json[i]);

                        //Append
                        $dropDown.append($option);
                    }
                }

                //Select currently
                var $selected = $dropDown.find("[value='" + oComponent.getParamVal("vimar/device-pid") + "']");
                var oVimarDevice = $selected.data("VimarByMe");

                $selected.prop("selected", true);

                var $fid = $componentProperties.find("[eve-manager-id='vimar/device-fid']");
                var $none = $("<option value='none' dictionary='None'>" + _D("None") + "</option>");

                //Empty combo selection
                $fid.empty();
                $fid.append($none);

                //Check if none device is selected
                if (oVimarDevice == undefined) {
                    $none.prop("selected", true);
                    $fid.prop("disabled", true);
                }
                else {
                    //Fill option parameters
                    for (var i = 0; i < oVimarDevice.fid.length; ++i) {
                        oVimarDevice.fid[i];
                        var $option = $("<option></option>");

                        $option.text(_D(oVimarDevice.fid[i].label));
                        $option.val(oVimarDevice.fid[i].value);

                        $fid.append($option);
                    }

                    $fid.removeProp("disabled");
                }

                //Select currently
                $fid.find("[value='" + oComponent.getParamVal("vimar/device-fid") + "']").prop("selected", true);
            }

            //Set Vimar physical address
            $Elem = $componentProperties.find("[eve-manager-id='vimar/physical-address']");
            $Elem.val(oComponent.getParamVal("vimar/physical-address"));

            //Set Vimar group address
            $Elem = $componentProperties.find("[eve-manager-id='vimar/group-address']");
            $Elem.val(oComponent.getParamVal("vimar/group-address"));

            /** Ghost */
            //Set virtual feedback
            var $Elem = $componentProperties.find("[eve-manager-id='ghost/virtual-feedback']");
            $Elem.prop("checked", oComponent.getParamVal("ghost/virtual-feedback"));

            $Elem = $componentProperties.find("[eve-manager-id='ghost/userdata']");
            $Elem.val(oComponent.getParamVal("ghost/userdata"));

            /** Z-Wave */
            $Elem = $componentProperties.find("[eve-manager-id='zwave/label']");
            $Elem.val(oComponent.getParamVal("zwave/label"));

            $Elem = $componentProperties.find("[eve-manager-id='zwave/node']");
            $Elem.val(oComponent.getParamVal("zwave/node"));

            $Elem = $componentProperties.find("[eve-manager-id='zwave/instance']");
            $Elem.val(oComponent.getParamVal("zwave/instance"));

            /** Vivaldi */
            {
                var json = blr.declarations.vivaldi.devices;
                $dropDown = $componentProperties.find("[eve-manager-id='vivaldi/device-pid']");
                var $none = $("<option value='none' dictionary='None'>" + _D("None") + "</option>");
                $dropDown.append($none);

                //Parsing Vivaldi Devices
                for (var i = 0; i < json.length; ++i) {
                    var $option = $("<option></option>");

                    //Check if is for Combo
                    if (json[i].componentsType.indexOf("info") != -1) {
                        $option.text(json[i].itemCodes.toString() + " - " + _D(json[i].label));
                        $option.attr("title", _D(json[i].label));
                        $option.val(json[i].pid);
                        $option.data("Vivaldi", json[i]);

                        //Append
                        $dropDown.append($option);
                    }
                }

                //Disable if exist one choice
                $dropDown.prop("disabled", true);

                //Select currently PID
                var $selected = $dropDown.find("[value='" + oComponent.getParamVal("vivaldi/device-pid") + "']");
                var oVivaldiDevice = $selected.data("Vivaldi");

                //Select vivaldi device
                $selected.prop("selected", true);

                //Fill RC20 address
                $dropDown = $componentProperties.find("[eve-manager-id='vivaldi/device-id']");
                for (var i = 0; i < oVivaldiDevice.idList.length; ++i) {
                    var $option = $("<option></option>");
                    $option.text(oVivaldiDevice.idList[i]);
                    $option.val(oVivaldiDevice.idList[i]);

                    $dropDown.append($option);
                }

                var $selected = $dropDown.find("[value='" + oComponent.getParamVal("vivaldi/device-id") + "']");
                $selected.prop("selected", true);

                //Fill Function ID
                $dropDown = $componentProperties.find("[eve-manager-id='vivaldi/device-fid']");
                for (var i = 0; i < oVivaldiDevice.fidList.length; ++i) {
                    if (oVivaldiDevice.fidList[i].fid == 7 || oVivaldiDevice.fidList[i].fid == 8)
                        continue;
                    var $option = $("<option></option>");
                    $option.text(oVivaldiDevice.fidList[i].label);
                    $option.val(oVivaldiDevice.fidList[i].fid);

                    $dropDown.append($option);
                }

                var $selected = $dropDown.find("[value='" + oComponent.getParamVal("vivaldi/device-fid") + "']");
                $selected.prop("selected", true);

            }

            /** Aernova */
            {
                var json = $.parseJSON(QT.readFile("./declarations/aernova/functions.json"));
                $dropDown = $componentProperties.find("[eve-manager-id='aernova/mode']");
                //Parsing Aernova modes
                for (var i = 0; i < json.length; ++i) {
                    var $option = $("<option></option>");

                    $option.text(_D(json[i].label));
                    $option.attr("title", _D(json[i].label));
                    $option.attr("dictionary", json[i].label);
                    $option.val(json[i].fid);
                    $option.data("Aernova", json[i]);

                    //Append
                    $dropDown.append($option);

                }
                var $selected = $dropDown.find("[value='" + oComponent.getParamVal("aernova/mode") + "']");
                $selected.prop("selected", true);
            }
            $Elem = $componentProperties.find("[eve-manager-id='aernova/address']");
            $Elem.val(oComponent.getParamVal("aernova/address"));

            /** BTicino */
            {
                var json = blr.declarations.bticino.functions;
                $dropDown = $componentProperties.find("[eve-manager-id='bticino/who']");
                var $none = $("<option value='none' dictionary='None'>" + _D("None") + "</option>");
                $dropDown.append($none);

                //Parsing BTicino WHOs
                // 1 stands for illuminations, 2 automatisms, 4 thermoregulation
                for (var i = 0; i < json.length; ++i) {
                    if (json[i].who == 1 || json[i].who == 2 || json[i].who == 4) {
                        var $option = $("<option></option>");
                        $option.text(_D(json[i].label));
                        $option.attr("title", _D(json[i].label));
                        $option.attr("dictionary", json[i].label);
                        $option.val(json[i].who);
                        $option.data("BTicino", json[i]);
                        $dropDown.append($option);
                    }
                }

                //currently selected WHO
                var $selected = $dropDown.find("[value='" + oComponent.getParamVal("bticino/who") + "']");
                var oBTicino = $selected.data("BTicino");
                $selected.prop("selected", true);

                var who = oComponent.getParamVal("bticino/who");

                //populate interface dropdown
                $dropDown = $componentProperties.find("[eve-manager-id='bticino/interface']");
                $none = $("<option value='none' dictionary='None'>" + _D("None") + "</option>");

                if (who != 'none' && (who == 1 || who == 2)) {
                    for (var i = 0; i < oBTicino.interfaces.length; ++i) {

                        var $option = $("<option></option>");
                        $option.text(_D(oBTicino.interfaces[i].label));
                        $option.attr("title", _D(oBTicino.interfaces[i].label));
                        $option.attr("dictionary", oBTicino.interfaces[i].label);
                        $option.val(oBTicino.interfaces[i].bus);

                        //Append
                        $dropDown.append($option);

                    }
                } else {
                    $dropDown.append($none);
                    $dropDown.prop("disabled", true);
                }

                $selected = $dropDown.find("[value='" + oComponent.getParamVal("bticino/interface") + "']").prop("selected", true);

                //populate address dropdown
                $dropDown = $componentProperties.find("[eve-manager-id='bticino/address']");
                $none = $("<option value='none' dictionary='None'>" + _D("None") + "</option>");

                if (who != 'none' && (who == 1 || who == 2)) {
                    for (var i = 0; i < oBTicino.addresses.length; ++i) {
                        var $option = $("<option></option>");
                        $option.text(_D(oBTicino.addresses[i].label));
                        $option.attr("title", _D(oBTicino.addresses[i].label));
                        $option.attr("dictionary", oBTicino.addresses[i].label);
                        $option.val(oBTicino.addresses[i].where);

                        //Append
                        $dropDown.append($option);

                    }
                } else {
                    $dropDown.append($none);
                    $dropDown.prop("disabled", true);
                }

                $selected = $dropDown.find("[value='" + oComponent.getParamVal("bticino/address") + "']").prop("selected", true);


                //populate sensor dropdown
                $dropDown = $componentProperties.find("[eve-manager-id='bticino/sensor']");
                $none = $("<option value='none' dictionary='None'>" + _D("None") + "</option>");

                if (who != 'none' && who == 4) {
                    for (var i = 0; i < oBTicino.sensors.length; ++i) {

                        var $option = $("<option></option>");
                        $option.text(_D(oBTicino.sensors[i].label));
                        $option.attr("title", _D(oBTicino.sensors[i].label));
                        $option.attr("dictionary", oBTicino.sensors[i].label);
                        $option.val(oBTicino.sensors[i].value);

                        //Append
                        $dropDown.append($option);
                    }
                } else {
                    $dropDown.append($none);
                    $dropDown.prop("disabled", true);
                }
                ;

                $selected = $dropDown.find("[value='" + oComponent.getParamVal("bticino/sensor") + "']").prop("selected", true);


                //populate zone dropdown
                $dropDown = $componentProperties.find("[eve-manager-id='bticino/zone']");
                $none = $("<option value='none' dictionary='None'>" + _D("None") + "</option>");

                if (who != 'none' && who == 4) {
                    for (var i = 0; i < oBTicino.zones.length; ++i) {

                        var $option = $("<option></option>");
                        $option.text(_D(oBTicino.zones[i].label));
                        $option.attr("title", _D(oBTicino.zones[i].label));
                        $option.attr("dictionary", oBTicino.zones[i].label);
                        $option.val(oBTicino.zones[i].value);

                        //Append
                        $dropDown.append($option);
                    }
                } else {
                    $dropDown.append($none);
                    $dropDown.prop("disabled", true);
                }

                $selected = $dropDown.find("[value='" + oComponent.getParamVal("bticino/zone") + "']").prop("selected", true);


                //populate function dropdown
                $dropDown = $componentProperties.find("[eve-manager-id='bticino/function']");
                $none = $("<option value='none' dictionary='None'>" + _D("None") + "</option>");

                if (who != 'none' && (who == 1 || who == 2 || who == 4)) {
                    for (var i = 0; i < oBTicino.functions.length; ++i) {
                        var $option = $("<option></option>");
                        $option.text(_D(oBTicino.functions[i].label));
                        $option.attr("title", _D(oBTicino.functions[i].label));
                        $option.attr("dictionary", oBTicino.functions[i].label);
                        $option.val(oBTicino.functions[i].fid);

                        //Append
                        $dropDown.append($option);
                    }
                } else {
                    $dropDown.append($none);
                    $dropDown.prop("disabled", true);
                }

                $selected = $dropDown.find("[value='" + oComponent.getParamVal("bticino/function") + "']").prop("selected", true);

            }


            /** ODIC */
            {
                var json = blr.declarations.odic.functions;
                //populate variable id dropdown
                $dropDown = $componentProperties.find("[eve-manager-id='odic/variableid']");
                for (var i = 0; i < json.variableId.length; ++i) {

                    var $option = $("<option></option>");
                    $option.text(_D(json.variableId[i].label));
                    $option.attr("title", _D(json.variableId[i].label));
                    $option.attr("dictionary", json.variableId[i].label);
                    $option.val(json.variableId[i].value);

                    //Append
                    $dropDown.append($option);

                }
                $selected = $dropDown.find("[value='" + oComponent.getParamVal("odic/variableid") + "']").prop("selected", true);

                //populate integer dropdown
                $dropDown = $componentProperties.find("[eve-manager-id='odic/type']");
                for (var i = 0; i < json.type.length; ++i) {

                    var $option = $("<option></option>");
                    $option.text(_D(json.type[i].label));
                    $option.attr("title", _D(json.type[i].label));
                    $option.attr("dictionary", json.type[i].label);
                    $option.val(json.type[i].value);

                    //Append
                    $dropDown.append($option);

                }
                $selected = $dropDown.find("[value='" + oComponent.getParamVal("odic/type") + "']").prop("selected", true);

                var type = oComponent.getParamVal("odic/type");
                if (type == 0) {
                    $Elem = $componentProperties.find("[eve-manager-id='odic/rmin']");
                    $Elem.on("keypress", function (evt) {
                        return bigh.onlyInt();
                    });
                    $Elem = $componentProperties.find("[eve-manager-id='odic/rmax']");
                    $Elem.on("keypress", function (evt) {
                        return bigh.onlyInt();
                    });
                    $Elem = $componentProperties.find("[eve-manager-id='odic/smin']");
                    $Elem.on("keypress", function (evt) {
                        return bigh.onlyInt();
                    });
                    $Elem = $componentProperties.find("[eve-manager-id='odic/smax']");
                    $Elem.on("keypress", function (evt) {
                        return bigh.onlyInt();
                    });
                    $Elem = $componentProperties.find("[eve-manager-id='odic/tmin']");
                    $Elem.on("keypress", function (evt) {
                        return bigh.onlyInt();
                    });
                    $Elem = $componentProperties.find("[eve-manager-id='odic/tmax']");
                    $Elem.on("keypress", function (evt) {
                        return bigh.onlyInt();
                    });
                }
                if (type == 1) {
                    $Elem = $componentProperties.find("[eve-manager-id='odic/rmin']");
                    $Elem.on("keypress", function (evt) {
                        return bigh.onlyFloat();
                    });
                    $Elem = $componentProperties.find("[eve-manager-id='odic/rmax']");
                    $Elem.on("keypress", function (evt) {
                        return bigh.onlyFloat();
                    });
                    $Elem = $componentProperties.find("[eve-manager-id='odic/smin']");
                    $Elem.on("keypress", function (evt) {
                        return bigh.onlyFloat();
                    });
                    $Elem = $componentProperties.find("[eve-manager-id='odic/smax']");
                    $Elem.on("keypress", function (evt) {
                        return bigh.onlyFloat();
                    });
                    $Elem = $componentProperties.find("[eve-manager-id='odic/tmin']");
                    $Elem.on("keypress", function (evt) {
                        return bigh.onlyFloat();
                    });
                    $Elem = $componentProperties.find("[eve-manager-id='odic/tmax']");
                    $Elem.on("keypress", function (evt) {
                        return bigh.onlyFloat();
                    });
                }
            }

            $Elem = $componentProperties.find("[eve-manager-id='odic/rmin']");
            $Elem.val(oComponent.getParamVal("odic/rmin"));

            $Elem = $componentProperties.find("[eve-manager-id='odic/rmax']");
            $Elem.val(oComponent.getParamVal("odic/rmax"));

            $Elem = $componentProperties.find("[eve-manager-id='odic/smin']");
            $Elem.val(oComponent.getParamVal("odic/smin"));

            $Elem = $componentProperties.find("[eve-manager-id='odic/smax']");
            $Elem.val(oComponent.getParamVal("odic/smax"));

            $Elem = $componentProperties.find("[eve-manager-id='odic/tmin']");
            $Elem.val(oComponent.getParamVal("odic/tmin"));

            $Elem = $componentProperties.find("[eve-manager-id='odic/tmax']");
            $Elem.val(oComponent.getParamVal("odic/tmax"));


            // Modbus
            {
                var json = blr.declarations.modbus.functions;
                //unit_id
                $dropDownRtuRead = $componentProperties.find("[eve-manager-id='modbusrtutcp/read-unit-id']");
                $dropDownRtuWrite = $componentProperties.find("[eve-manager-id='modbusrtutcp/write-unit-id']");
                $dropDownTcpRead = $componentProperties.find("[eve-manager-id='modbustcp/read-unit-id']");
                $dropDownTcpWrite = $componentProperties.find("[eve-manager-id='modbustcp/write-unit-id']");
                for (var i = 0; i < json.unit_id.length; ++i) {
                    var $option = $("<option></option>");
                    $option.text(_D(json.unit_id[i].label));
                    $option.attr("title", _D(json.unit_id[i].label));
                    $option.attr("dictionary", json.unit_id[i].label);
                    $option.val(json.unit_id[i].value);
                    //Append
                    $dropDownRtuRead.append($option);
                    $dropDownRtuWrite.append($option.clone());
                    $dropDownTcpRead.append($option.clone());
                    $dropDownTcpWrite.append($option.clone());
                }
                $selected = $dropDownRtuRead.find("[value='" + oComponent.getParamVal("modbusrtutcp/read-unit-id") + "']").prop("selected", true);
                $selected = $dropDownRtuWrite.find("[value='" + oComponent.getParamVal("modbusrtutcp/write-unit-id") + "']").prop("selected", true);
                $selected = $dropDownTcpRead.find("[value='" + oComponent.getParamVal("modbustcp/read-unit-id") + "']").prop("selected", true);
                $selected = $dropDownTcpWrite.find("[value='" + oComponent.getParamVal("modbustcp/write-unit-id") + "']").prop("selected", true);

                //all_transform_type
                $dropDownRtuRead = $componentProperties.find("[eve-manager-id='modbusrtutcp/read-transform-type']");
                $dropDownRtuWrite = $componentProperties.find("[eve-manager-id='modbusrtutcp/write-transform-type']");
                $dropDownTcpRead = $componentProperties.find("[eve-manager-id='modbustcp/read-transform-type']");
                $dropDownTcpWrite = $componentProperties.find("[eve-manager-id='modbustcp/write-transform-type']");
                for (var i = 0; i < json.all_transform_type.length; ++i) {
                    var $option = $("<option></option>");
                    $option.text(_D(json.all_transform_type[i].label));
                    $option.attr("title", _D(json.all_transform_type[i].label));
                    $option.attr("dictionary", json.all_transform_type[i].label);
                    $option.val(json.all_transform_type[i].value);
                    //Append
                    $dropDownRtuRead.append($option);
                    $dropDownRtuWrite.append($option.clone());
                    $dropDownTcpRead.append($option.clone());
                    $dropDownTcpWrite.append($option.clone());
                }
                $selected = $dropDownRtuRead.find("[value='" + oComponent.getParamVal("modbusrtutcp/read-transform-type") + "']").prop("selected", true);
                $selected = $dropDownRtuWrite.find("[value='" + oComponent.getParamVal("modbusrtutcp/write-transform-type") + "']").prop("selected", true);
                $selected = $dropDownTcpRead.find("[value='" + oComponent.getParamVal("modbustcp/read-transform-type") + "']").prop("selected", true);
                $selected = $dropDownTcpWrite.find("[value='" + oComponent.getParamVal("modbustcp/write-transform-type") + "']").prop("selected", true);


                //read_function_id
                $dropDownRtuRead = $componentProperties.find("[eve-manager-id='modbusrtutcp/read-function-id']");
                $dropDownTcpRead = $componentProperties.find("[eve-manager-id='modbustcp/read-function-id']");
                for (var i = 0; i < json.read_function_id.length; ++i) {

                    var $option = $("<option></option>");
                    $option.text(_D(json.read_function_id[i].label));
                    $option.attr("title", _D(json.read_function_id[i].label));
                    $option.attr("dictionary", json.read_function_id[i].label);
                    $option.val(json.read_function_id[i].value);

                    //Append
                    $dropDownRtuRead.append($option);
                    $dropDownTcpRead.append($option.clone());
                }
                $selected = $dropDownRtuRead.find("[value='" + oComponent.getParamVal("modbusrtutcp/read-function-id") + "']").prop("selected", true);
                $selected = $dropDownTcpRead.find("[value='" + oComponent.getParamVal("modbustcp/read-function-id") + "']").prop("selected", true);


                //write_function_id
                $dropDownRtuWrite = $componentProperties.find("[eve-manager-id='modbusrtutcp/write-function-id']");
                $dropDownTcpWrite = $componentProperties.find("[eve-manager-id='modbustcp/write-function-id']");
                for (var i = 0; i < json.write_function_id.length; ++i) {

                    var $option = $("<option></option>");
                    $option.text(_D(json.write_function_id[i].label));
                    $option.attr("title", _D(json.write_function_id[i].label));
                    $option.attr("dictionary", json.write_function_id[i].label);
                    $option.val(json.write_function_id[i].value);

                    //Append
                    $dropDownRtuWrite.append($option);
                    $dropDownTcpWrite.append($option.clone());
                }
                $selected = $dropDownRtuWrite.find("[value='" + oComponent.getParamVal("modbusrtutcp/write-function-id") + "']").prop("selected", true);
                $selected = $dropDownTcpWrite.find("[value='" + oComponent.getParamVal("modbustcp/write-function-id") + "']").prop("selected", true);

            }

            // ModbusTCP Read
            $Elem = $componentProperties.find("[eve-manager-id='modbustcp/read-unit-id']");
            $Elem.val(oComponent.getParamVal("modbustcp/read-unit-id"));

            $Elem = $componentProperties.find("[eve-manager-id='modbustcp/read-function-id']");
            $Elem.val(oComponent.getParamVal("modbustcp/read-function-id"));

            $Elem = $componentProperties.find("[eve-manager-id='modbustcp/read-register-start']");
            $Elem.val(oComponent.getParamVal("modbustcp/read-register-start"));

            $Elem = $componentProperties.find("[eve-manager-id='modbustcp/read-register-count']");
            $Elem.val(oComponent.getParamVal("modbustcp/read-register-count"));

            $Elem = $componentProperties.find("[eve-manager-id='modbustcp/read-bit-start']");
            $Elem.val(oComponent.getParamVal("modbustcp/read-bit-start"));

            $Elem = $componentProperties.find("[eve-manager-id='modbustcp/read-bit-count']");
            $Elem.val(oComponent.getParamVal("modbustcp/read-bit-count"));

            $Elem = $componentProperties.find("[eve-manager-id='modbustcp/read-transform-type']");
            $Elem.val(oComponent.getParamVal("modbustcp/read-transform-type"));

            $Elem = $componentProperties.find("[eve-manager-id='modbustcp/read-transform-min']");
            $Elem.val(oComponent.getParamVal("modbustcp/read-transform-min"));

            $Elem = $componentProperties.find("[eve-manager-id='modbustcp/read-transform-max']");
            $Elem.val(oComponent.getParamVal("modbustcp/read-transform-max"));

            $Elem = $componentProperties.find("[eve-manager-id='modbustcp/read-transform-multiplier']");
            $Elem.val(oComponent.getParamVal("modbustcp/read-transform-multiplier"));

            $Elem = $componentProperties.find("[eve-manager-id='modbustcp/read-transform-digits']");
            $Elem.val(oComponent.getParamVal("modbustcp/read-transform-digits"));

            $Elem = $componentProperties.find("[eve-manager-id='modbustcp/read-transform-digits-format']");
            $Elem.val(oComponent.getParamVal("modbustcp/read-transform-digits-format"));

            // ModbusTCP Write
            $Elem = $componentProperties.find("[eve-manager-id='modbustcp/write-unit-id']");
            $Elem.val(oComponent.getParamVal("modbustcp/write-unit-id"));

            $Elem = $componentProperties.find("[eve-manager-id='modbustcp/write-function-id']");
            $Elem.val(oComponent.getParamVal("modbustcp/write-function-id"));

            $Elem = $componentProperties.find("[eve-manager-id='modbustcp/write-register-start']");
            $Elem.val(oComponent.getParamVal("modbustcp/write-register-start"));

            $Elem = $componentProperties.find("[eve-manager-id='modbustcp/write-register-count']");
            $Elem.val(oComponent.getParamVal("modbustcp/write-register-count"));

            $Elem = $componentProperties.find("[eve-manager-id='modbustcp/write-bit-start']");
            $Elem.val(oComponent.getParamVal("modbustcp/write-bit-start"));

            $Elem = $componentProperties.find("[eve-manager-id='modbustcp/write-bit-count']");
            $Elem.val(oComponent.getParamVal("modbustcp/write-bit-count"));

            $Elem = $componentProperties.find("[eve-manager-id='modbustcp/write-transform-type']");
            $Elem.val(oComponent.getParamVal("modbustcp/write-transform-type"));

            $Elem = $componentProperties.find("[eve-manager-id='modbustcp/write-transform-min']");
            $Elem.val(oComponent.getParamVal("modbustcp/write-transform-min"));

            $Elem = $componentProperties.find("[eve-manager-id='modbustcp/write-transform-max']");
            $Elem.val(oComponent.getParamVal("modbustcp/write-transform-max"));

            $Elem = $componentProperties.find("[eve-manager-id='modbustcp/write-data-multiplier']");
            $Elem.val(oComponent.getParamVal("modbustcp/write-data-multiplier"));


            // ModbusRTUTCP Read
            $Elem = $componentProperties.find("[eve-manager-id='modbusrtutcp/read-unit-id']");
            $Elem.val(oComponent.getParamVal("modbusrtutcp/read-unit-id"));

            $Elem = $componentProperties.find("[eve-manager-id='modbusrtutcp/read-function-id']");
            $Elem.val(oComponent.getParamVal("modbusrtutcp/read-function-id"));

            $Elem = $componentProperties.find("[eve-manager-id='modbusrtutcp/read-register-start']");
            $Elem.val(oComponent.getParamVal("modbusrtutcp/read-register-start"));

            $Elem = $componentProperties.find("[eve-manager-id='modbusrtutcp/read-register-count']");
            $Elem.val(oComponent.getParamVal("modbusrtutcp/read-register-count"));

            $Elem = $componentProperties.find("[eve-manager-id='modbusrtutcp/read-bit-start']");
            $Elem.val(oComponent.getParamVal("modbusrtutcp/read-bit-start"));

            $Elem = $componentProperties.find("[eve-manager-id='modbusrtutcp/read-bit-count']");
            $Elem.val(oComponent.getParamVal("modbusrtutcp/read-bit-count"));

            $Elem = $componentProperties.find("[eve-manager-id='modbusrtutcp/read-transform-type']");
            $Elem.val(oComponent.getParamVal("modbusrtutcp/read-transform-type"));

            $Elem = $componentProperties.find("[eve-manager-id='modbusrtutcp/read-transform-min']");
            $Elem.val(oComponent.getParamVal("modbusrtutcp/read-transform-min"));

            $Elem = $componentProperties.find("[eve-manager-id='modbusrtutcp/read-transform-max']");
            $Elem.val(oComponent.getParamVal("modbusrtutcp/read-transform-max"));

            $Elem = $componentProperties.find("[eve-manager-id='modbusrtutcp/read-transform-multiplier']");
            $Elem.val(oComponent.getParamVal("modbusrtutcp/read-transform-multiplier"));

            $Elem = $componentProperties.find("[eve-manager-id='modbusrtutcp/read-transform-digits']");
            $Elem.val(oComponent.getParamVal("modbusrtutcp/read-transform-digits"));

            $Elem = $componentProperties.find("[eve-manager-id='modbusrtutcp/read-transform-digits-format']");
            $Elem.val(oComponent.getParamVal("modbusrtutcp/read-transform-digits-format"));

            // ModbusRTUTCP Write
            $Elem = $componentProperties.find("[eve-manager-id='modbusrtutcp/write-unit-id']");
            $Elem.val(oComponent.getParamVal("modbusrtutcp/write-unit-id"));

            $Elem = $componentProperties.find("[eve-manager-id='modbusrtutcp/write-function-id']");
            $Elem.val(oComponent.getParamVal("modbusrtutcp/write-function-id"));

            $Elem = $componentProperties.find("[eve-manager-id='modbusrtutcp/write-register-start']");
            $Elem.val(oComponent.getParamVal("modbusrtutcp/write-register-start"));

            $Elem = $componentProperties.find("[eve-manager-id='modbusrtutcp/write-register-count']");
            $Elem.val(oComponent.getParamVal("modbusrtutcp/write-register-count"));

            $Elem = $componentProperties.find("[eve-manager-id='modbusrtutcp/write-bit-start']");
            $Elem.val(oComponent.getParamVal("modbusrtutcp/write-bit-start"));

            $Elem = $componentProperties.find("[eve-manager-id='modbusrtutcp/write-bit-count']");
            $Elem.val(oComponent.getParamVal("modbusrtutcp/write-bit-count"));

            $Elem = $componentProperties.find("[eve-manager-id='modbusrtutcp/write-transform-type']");
            $Elem.val(oComponent.getParamVal("modbusrtutcp/write-transform-type"));

            $Elem = $componentProperties.find("[eve-manager-id='modbusrtutcp/write-transform-min']");
            $Elem.val(oComponent.getParamVal("modbusrtutcp/write-transform-min"));

            $Elem = $componentProperties.find("[eve-manager-id='modbusrtutcp/write-transform-max']");
            $Elem.val(oComponent.getParamVal("modbusrtutcp/write-transform-max"));

            $Elem = $componentProperties.find("[eve-manager-id='modbusrtutcp/write-transform-multiplier']");
            $Elem.val(oComponent.getParamVal("modbusrtutcp/write-transform-multiplier"));


            //Set virtual feedback
            var $Elem = $componentProperties.find("[eve-manager-id='gui/label']");
            $Elem.val(oComponent.getParamVal("gui/label"));
        }

        updateCustomData(oComponent);

    };

    function onUpdate_protocol(strProtocol, data) {
        switch (strProtocol) {
            case "elmo":{
                return onUpdate_elmo(data);
            }break;
        }
        return false;
    }


    function onUpdate_mainframe(data) {
        var $Elem = undefined;
        return true;
    }

    function onGuiInit_vivaldigiovefree(data) {
        //console.log("onGuiInit_vivaldigiovefree");
        var jsonData = blr.declarations.vivaldi.giovefree.addresses;
        var $dropDown = data.$properties().find("[eve-manager-id='vivaldigiovefree/device-id']");
        for (var i = 0; i < jsonData.length; ++i) {
            var $option = $("<option></option>");
            $option.val(jsonData[i]);
            $option.text(jsonData[i]);
            $dropDown.append($option);
        }
        var $selected = $dropDown.find("[value='" + data.node().getParamVal("vivaldigiovefree/device-id") + "']");
        $selected.prop("selected", true);

        jsonData = blr.declarations.vivaldi.giovefree.info_fids;
        $dropDown = data.$properties().find("[eve-manager-id='vivaldigiovefree/device-fid']");
        for (var i = 0; i < jsonData.length; ++i) {
            var $option = $("<option></option>");
            $option.val(jsonData[i].fid);
            $option.text(_D(jsonData[i].label));
            $dropDown.append($option);
        }
        var $selected = $dropDown.find("[value='" + data.node().getParamVal("vivaldigiovefree/device-fid") + "']");
        $selected.prop("selected", true);
        return true;
    }

    function onGuiChange_vivaldigiovefree(sender) {
        //console.log("onGuiChange_vivaldigiovefree");
        var oNode = application.getSelectComponent().getData();
        var $this = $(sender);
        var strParam = $this.attr("eve-manager-id");
        var strValue = $this.find(":selected").val();
        //Save in Model
        $.publish("/model/components/" + oNode.id + "/update/parameter", [oNode, strParam, strValue]);
        $.publish("/view/components/" + oNode.id + "/refresh/parameter", [oNode, strParam]);
        return true;
    }

    function onUpdate_vivaldigiovefree(data) {
        //console.log("onUpdate_vivaldigiovefree");
        // We set the current value under onGuiInit, so the value is always synced
        return true;
    }

    function onUpdate_elmo(data) {
        // We set the current value under onGuiInit, so the value is always synced

        var json = blr.declarations.elmo.fields;

        //read_function_id
        var $dropDown = $componentProperties.find("[eve-manager-id='elmo/read-variable']");
        for(var i=0; i<json.read_info.length; ++i){
            var $option = $("<option></option>");
            $option.text(_D(json.read_info[i].label));
            $option.attr("title", _D(json.read_info[i].label));
            $option.attr("dictionary", json.read_info[i].label);
            $option.val(json.read_info[i].value);
            //Append
            $dropDown.append($option);
        }


        var $selected = $dropDown.find("[value='"+ oComponent.getParamVal("") +"']").prop("selected",true);

        var $Elem = $componentProperties.find("[eve-manager-id='elmo/read-variable']");
        $Elem.val(oComponent.getParamVal("elmo/read-variable"));



        return true;
    }

    function onUpdate_default(data) {
        return true;
    }


}
catch(err){
    console.error(err);
}
