/** scenarioEditor class (extends Window class)
 *
 * @class scenarioEditor
 *
 *
 * @author <a href="mailto:info@ilevia.com">info@ilevia.com</a>
 *
 */
"use strict";

function addComponentsList(oWindow){
	
	var self = this;

    var listOfComponents={};

    this.componentParam="";
	/** Initialization
	 *
	 */
	var init = function(){


        console.log("%cWindow - addComponents class initialization (extends Window class)","color:green");
      
        //Create jQuery UI dialog
        m_$element.dialog({
            height: 400,
            minHeight:300,
            width: 400,
            minWidth: 300,
            autoOpen: false,
            title: _D("Drag & drop components here" ),
            closeText: _D("save and close"),
            modal: false,
            create: function(e,ui){
                var $this = $(this);
                var $components = $this.find(".components");
                var $composition = $this.find(".composition");
                
                //$this.find("> div").w2layout({
                $this.w2layout({
                    name: "ghost-addComponentsList-editor",
                    panels: [
                        { type: "main", minSize:400, style: "background-color: #333; border: 1px solid #dfdfdf; padding:0px; z-index:auto;", content: $composition[0], overflow: "hidden" }
                    ]
                });

                //Dinamically hide overflow
                $("#layout_ghost-addComponentsList-editor_panel_main").css("overflow","hidden");
            },
            resize: function(e,ui){
                var $this = $(this);
                var intOffset = 45;

                $this.find(".actions-box").height(parseInt($this.height(),10) - intOffset);
            },
            open: function(e,ui){
                var $this = $(this);
                var intOffset = 45;
                
                $this.trigger("resize");
                $this.find(".actions-box").height(parseInt($this.height(),10) - intOffset);
                m_$element.parent().find(".ui-dialog-title").text("Set group of components for : "+m_$element.oComp.m_Data.name);

            },
            close: m_oWindow.hide
        });

        //Droppable attach component
        m_$element.find(".attachcomponent").droppable({
            //accept: m_$element_.find(".components [eve-manager-component='switch'], .components [eve-manager-component='lock'], .components [eve-manager-component='pulse']"),
            //accept: "#scenarioEditor .components [eve-manager-component='switch'], #scenarioEditor .components [eve-manager-component='power'], #scenarioEditor .components [eve-manager-component='lock'], #scenarioEditor .components [eve-manager-component='pulse']",
            //accept: "[eve-manager-component='switch'], [eve-manager-component='lock'], [eve-manager-component='pulse']",
            //accept: "[eve-manager-component='switch'], [eve-manager-component='lock'], [eve-manager-component='pulse'], [eve-manager-component='timer']",
            activeClass: "accept",
            drop: self._setAttachedComponent
        });
        
        //Empty attached
        m_$element.on("click",".attachcomponent .ui-icon-trash",function(e){
            $(this).parents(".attachcomponent").empty();

        });
        
        //Ghost - scenario composition
        m_$element.find(".actions").sortable($.extend(false,basicSortable),{
            //appendTo: "#scenarioComposition .actions-box",
            //containment: "#scenarioComposition .actions-box",
            //connectWith: "#scenarioComposition .components",
            
            //Check utility
            appendTo: m_$element.find(".actions-box"),
            //containment: m_$element_.find(".actions-box"),
            connectWith: m_$element.find(".components"),
            forcePlaceholderSize: true,
            scroll: true,
            //receive: self._addActionComponent
            receive: function(e,ui){
                var $this = $(this);
                var $helper = $this.find("[eve-manager-component]");
                var oNode = ui.item.data("eveManagerNode");
                var $element = self._addAction(oNode);
                
                $helper.before($element);                                                                   //Append html element
        
                //Remove helper
                $helper.remove();
            }
        });

        //Remove action
        m_$element.on("click",".actions .ui-icon-trash",function(e){
            var obj=$(this).parents("li").data()["eveManagerNode"];
            listOfComponents[obj.data.UId]="no";
            $(this).parents("li").remove();

        });

        //Get filters
        $.ajax({
            dataType: "json",
            url: "./declarations/addComponents/ghost/attached-components.json",
            async: false,
            success: function(aData){
                
                var str = "";
                for(var i=0; i<aData.length; ++i){
                    str += "[eve-manager-component='"+ aData[i] +"'],";
                }
                str = str.substring(0, str.length - 1);
                
                m_$element.find(".attachcomponent").droppable("option", "accept", str);
            },
            error: function(jqXHR, textStatus, errorThrown){
                console.error(errorThrown);
                m_oWindow.hide();                                   //Call external window hide method
            }
        });
        
        //Get black list components
        $.ajax({
            dataType: "json",
            url: "./declarations/addComponents/ghost/black-list.json",
            async: false,
            success: function(aData){
                self["black-list"] = aData;
            },
            error: function(jqXHR, textStatus, errorThrown){
                console.error(errorThrown);
                m_oWindow.hide();                                   //Call external window hide method
            }
        });
    };
	
	/** Extended window object 
     * @type {Window}
     */
	var m_oWindow = oWindow;
	
	/** jQuery DOM element representing Window GUI
     * @type {jQuery}
     */
    var m_$element;
    
	/** Component action
     * @type Array
     */
    this["black-list"] = new Array();


    this.getScenarioActionHtmlElement = function()
    {
        var $element = $("<li></li>");
        var $name = $("<span></span>");
        var $wrapper = $("<div></div>");
        //var $remove = $("<button type='button'>-</button>");
        var $remove = $("<span>&nbsp;</span>");

        //
        $name.addClass("name");
        $wrapper.addClass("wrapper");
        $remove.addClass("remove");
        $remove.addClass("ui-icon").addClass("ui-icon-trash");

        //Create element html

        $wrapper.append($name);
        $element.append($wrapper);
        $element.append($remove);


        return $element;

    };

    var oComponent;

	
	/** Show icon editor window
	 */
	this.show = function(oParam){
        this.componentParam=oParam;
        if(!m_oWindow.getActiveNode().getData() instanceof Component){
            console.error("Active node is not Component instance");
            return;
        }

        //Get component
        var oNode = m_oWindow.getActiveNode();
        var oComponent = oNode.getData();
        m_$element.oComp=oComponent;
        var tmp=oComponent.getParamVal(this.componentParam);

        var oComposition =[];
        if (tmp!=undefined && tmp!="") oComposition=JSON.parse(tmp);

        var $originalContainer = $("#componentscontainer");                                    //Get original components container
        var $clonedComponents = $originalContainer.children().clone(true,true);                //Get cloned html components
	    var $componentsContainer = m_$element.find(".components");


        //Fill avaiable components
	    $componentsContainer.empty();
	    $componentsContainer.append($clonedComponents);
	    
	    var $components = $componentsContainer.find("[eve-manager-component]");
	    $components.removeClass("select").removeClass("ui-state-active").removeAttr("id");
        //$components.find("canvas").attr("width",32).attr("height",32);

	    $("#componentscontainer li").draggable({
            appendTo: "body",
            containment: "body",
            revert: "invalid",
            revertDuration: false,
            connectToSortable: m_$element.find(".actions"),
            helper: function(e){ return $(e.currentTarget).clone(true); },
            start: function(e,ui){
                m_$element.find(".actions-box").addClass("accept");
                
            },
            stop: function(e,ui){
                m_$element.find(".actions-box").removeClass("accept");
            },
            zIndex: 1000
        });
	    
	    //Hide black-list components
	    for(var i=0; i<self["black-list"].length; ++i){
            
            if(self["black-list"][i]["parameter"] != undefined){
                var $componentByType = $componentsContainer.find("[eve-manager-component='"+ self["black-list"][i]["type"] +"']");
                
                for(var j=0; j<$componentByType.length; ++j){
                    var oNode = $( $componentByType[j] ).data("eveManagerNode");
                    var oComponent = oNode.getData();
                    
                    switch(self["black-list"][i]["parameter"]){
                        case "gateway":
                            if(oComponent.getParamVal(self["black-list"][i]["parameter"]).getData().getProtocol() == self["black-list"][i]["value"]){
                                $( $componentByType[j] ).hide();
                            }
                            break;
                        default:
                            if(oComponent.getParamVal(self["black-list"][i]["parameter"]) == self["black-list"][i]["value"]){
                                $( $componentByType[j] ).hide();
                            }
                    }
                }
            }
            else{
                $componentsContainer.find("[eve-manager-component='"+ self["black-list"][i]["type"] +"']").hide();
            }
            
        }
	    
	    //var oComposition = oComponent.getParamVal("ghost");
	    


        //Fill components actions
        if(oComposition != undefined )
        {
            var $actions = m_$element.find(".actions");

         /*   for (var i in listOfComponents)
            {
                //var entry=listOfComponents[i];
                var oTempNode = application.getComponentByUid( parseInt(i)  );
                var oTempComponent = oTempNode.getData();
                var oTempParent = oTempNode.getParent();
                var oTempParentComponent = oTempParent.getData();
                var oDescriptor = oTempComponent.getDescriptor();
                var $element = self._addAction( oTempNode);
                if ($element!=undefined)
                {
                    //Set element parameters
                    //   $element.find(".category").text((oTempParentComponent.getParamVal)?oTempParentComponent.getParamVal("name"):_D("none"));
                    $element.find(".name").text(oTempComponent.getParamVal("name"));


                    //   $element.find(".value").val(oComposition.actions[i].value);
                    //  var $componentActions = $element.find(".actions");
                    //  $componentActions.find("[value='"+ oComposition.actions[i].action +"']").prop("selected",true);

                    $element.data("eveManagerNode",oTempNode);
                    $actions.append($element);
                }
            };
*/
            //Fill components actions
            if(oComposition != undefined ){
                var $actions = m_$element.find(".actions");

                for(var i=0; i<oComposition.length; ++i){
                    var oTempNode = application.getComponentByUid( oComposition[i].UId );

                    if (oTempNode!= undefined)
                    {
                        var oTempComponent = oTempNode.getData();
                        var oTempParent = oTempNode.getParent();
                        var oTempParentComponent = oTempParent.getData();
                        var oDescriptor = oTempComponent.getDescriptor();

                        var $element = self._addAction( oTempNode);
                        if ($element!= undefined)
                        {

                            //Set element parameters
                            //     $element.find(".category").text((oTempParentComponent.getParamVal)?oTempParentComponent.getParamVal("name"):_D("none"));

                            // $element.find(".name").text((oTempParentComponent.getParamVal)+" "+oTempParentComponent.getParamVal("name"));

                            var group="";
                            try {group=oTempParent.getData().getParamVal("name") +" - "} catch (e){};

                            $element.find(".name").text( group + oTempComponent.getParamVal("name") );


                            //   $element.find(".value").val(oComposition.actions[i].value);

                            var $componentActions = $element.find(".actions");

                            //    $componentActions.find("[value='"+ oComposition.actions[i].action +"']").prop("selected",true);

                            $element.data("eveManagerNode",oTempNode);
                            $actions.append($element);
                            listOfComponents[oComposition[i].UId.toString()]="ok";
                        }
                    }

                }
            }
        }
	    m_$element.dialog("open");
	};
	
	/** Hide icon editor window and closing operation
     *
	 */
	this.hide = function(e,ui){
        var $components = m_$element.find(".components");
        var $attachcomponent = m_$element.find(".attachcomponent");
        var $actionscomponents = m_$element.find(".actions");
        var $attached = $attachcomponent.children();
        var $actions = $actionscomponents.children("li");
        var serialized = new Object();

        //Actions component
        serialized.actions = new Array();
        
        for(var i = 0; i < $actions.length; ++i){
            var $current = $($actions[i]);
            var parameters = new Object();
            var oComponent = $current.data("eveManagerNode").getData();
            var oDescriptor = oComponent.getDescriptor();
            
            //Parameters
            parameters = {
                UId: oComponent.UId
            };

            //console.log(parameters);
            
            serialized.actions.push(parameters);
        }
        
        //Add serialized composition
        var oComponent = m_oWindow.getActiveNode().getData();
       // oComponent.setParamVal(this.componentParam,JSON.stringify(serialized.actions));                                         //Set ghost parameter
        oComponent.setParamVal(this.componentParam,JSON.stringify(serialized.actions));                                         //Set ghost parameter

        //console.error(serialized);

        /*
        //Check correct
        $("#componentproperties .container").html(QT.readFile("./components/"+ oComponent.getType() +"/"+ oComponent.getType() +".html"));
        onUpdateComponent("Window-addComponentsList.js",COMPONENT);
        */

        var eventData = new blrComponentEventData(
            "Window-addComponentsList.js",
            $("#componentproperties"),
            oComponent
        );
        eventData.$properties().find("[eve-manager-components='mainframe']").html(QT.readFile("./components/mainframe/components-mainframe.html"));
        eventData.$properties().find("[eve-manager-components='bottom']").html(QT.readFile("./components/mainframe/bottom-prop.html"));
        COMPONENTS_MAINFRAME.onGuiChangeGatewayCallbackUserData = eventData;
        COMPONENTS_MAINFRAME.onGuiChangeGatewayCallback = onGuiChangeGateway;
        onInitComponent(eventData);
        onUpdateComponent(eventData);

        eventData = null;

        //Empty html
        listOfComponents=[];
        $attachcomponent.empty();                                                           //Empty attached component container
        $actionscomponents.empty();                                                         //Empty actions container
        
        //console.log(serialized);
        $("#componentscontainer li").draggable("destroy");
	};
	
	/** Assign window HTML element 
     * @param $element jQuery element represent this window
     * @returns {Node}  
     */
    this.assignWindow = function($element){
        m_$element = $element;
        
        //Initialization after graphic ready
        init();
    };
    
    /** Interactions methods */
    
    /** Set attached component
     * 
     */
    this._setAttachedComponent = function(e,ui){
        var $this = $(this);
        //var $element = $this.children("[eve-manager-component]");
        var $element = ui.helper;
        var $attached = $this.children(".attached");
        var oNode = $element.data("eveManagerNode");
        var oParentNode = oNode.getParent();
        var oComponent = oNode.getData();
        var oParentData = oParentNode.getData();
        
        //Check attached element existance (create element html)
        if($attached.length < 1){
            $attached = getScenarioAttachHtmlElement();                                         //Create new
            $this.append($attached);                                                            //Append element to list
        }
        
       // var strCategory = (oParentData.getParamVal)?oParentData.getParamVal("name"):_D("none");
       // $attached.find(".category-txt").text(strCategory);                                      //Set attached element category
        $attached.find(".name-txt").text(oComponent.getParamVal("name"));                       //Set attached element name
        
        $attached.data("eveManagerNode",oNode);
    };
    
    /** Add action component
     * 
     */
    this._addAction = function(oNode){
        var oComponent = oNode.getData();
        var oParentNode = oNode.getParent();
        var oParentComponent = oParentNode.getData();
        var oDescriptor = oComponent.getDescriptor();
        var $element =this.getScenarioActionHtmlElement();

        if ( listOfComponents[oComponent.UId.toString()]!="ok")
        {
            listOfComponents[oComponent.UId.toString()]="ok";
            //Set element parameters
            //  $element.find(".category").text((oParentComponent.getParamVal)?oParentComponent.getParamVal("name"):_D("none"));
            //$element.find(".name").text((oComponent.getParamVal)+" "+oTempParentComponent.getParamVal("name"));
            var group="";
            try {group=oParentNode.getData().getParamVal("name") +" - "} catch (e){};

            $element.find(".name").text( group + oComponent.getParamVal("name") );
            //  $element.find(".value").val(oDescriptor.getDefaultValue());

           
            //Enable/disable actions selector
            if(oDescriptor.isActionEditable()){
                $element.find(".actions").removeProp("disabled");
            }
            else{
                $element.find(".actions").prop("disabled",true);
            }

            //Enable/disable value field
            if(oDescriptor.isValueEditable()){
                $element.find(".value").show();
            }
            else{
                $element.find(".value").hide();
            }
            /*
             var $componentActions = $element.find(".actions");
             var oActionDescription = oDescriptor.getDescriptions();

             //Append options
             for(var k in oActionDescription){
             var $option = $("<option></option>");
             $option.val(k);
             $option.text(oActionDescription[k]);
             $componentActions.append($option);
             }

             //Set default action
             var iAction = oDescriptor.getDefaultAction();
             $componentActions.find("[value='"+ iAction +"']").prop("selected",true);
             */
            $element.data("eveManagerNode",oNode);                                                      //Set node data with html element

            return $element;
            /*$helper.before($element);                                                                   //Append html element

             //Remove helper
             $helper.remove();*/
        }

    };
    
    /** Confirm changes
     * 
     */
    this._submit = function(e){
        //Call external window hide method
        m_oWindow.hide();
    };
}