/** Eve Manager Graphic User Interface
 *
 *
 * @author <a href="mailto:info@ilevia.com">info@ilevia.com</a>
 *
 *
 * @required <a href="http://jquery.com/">jQuery</a>
 * @required <a href="http://jqueryui.com/">jQuery UI</a>
 */
"use strict";

//Component
var basicSortable = { scroll: false, connectWith: "ul, div", appendTo: document.body, axis: "y", opacity: 0.75 };
var basicAccordion = { active: false, animate: false, collapsible: true, heightStyle: "content" };
var groupAccordion = $.extend(false,basicAccordion,{
	active: false,
	create: function(e,ui){
		var $this = $(this);
		var $head = $this.find("h3");
		var $content = $this.find("ul");

		$content.sortable($.extend(false,basicSortable,{
            //tolerance: "pointer",
            distance: 3,
		    update:function(e,ui){
		        var $this = $(this);
		        
		        //Check children
		        if($this.children().length < 1){
		            $this.css("padding","32px");
		        }
		        else{
		            $this.css("padding","2px");
		        }
		    }
	    //}));
        //})).sortable( "option", "connectWith", "ul, div" );
        })).sortable( "option", "connectWith", "#library ul, #componentscontainer, #componentscontainer ul" );
	}});
var mapElementsDraggable = {
    //containment: $("#interface-maps .maps-container .viewer"),
    //containment: "parent",
    stop: function(e,ui){
        return;
        //Update element position
        var posX = parseInt(ui.position.left,10);
        var posY = parseInt(ui.position.top);
        //console.log("posX: "+ posX +" posY: "+ posY);
    }
};
var relationDroppable = {
    accept: "#relations-components > .container li",
    activeClass: "ui-state-active",
    hoverClass: "ui-state-highlight",
    tolerance:"pointer"
};


/** On ready operations */
$(function(){
	
	//Layout
	var pstyle = "background-color: #333; border: 1px solid #dfdfdf; padding:0px; z-index:auto;";
	
	// Eve Manager configuration
	/*$('#interface').w2layout({
	    name: 'interface',
	    panels: [
	        { type: "main", minSize:500, style: pstyle, content: $("#myinterface")[0] },
	        { type: 'right', size: 300, minSize:230, resizable: true, style: pstyle, content: $("#interface-elements")[0] }
	    ]
    });*/

    /* Create resizable layout for Interface and Maps tab */
    $('#interface').w2layout({
	    name: 'interface',
	    panels: [
	    	{ type: 'left', size: 120, minSize:120, resizable: true, style: pstyle, content: $("#myinterface")[0], overflow: "hidden" },
	        { type: "main", minSize:1050, style: pstyle, content: $("#interface-maps")[0], overflow: "hidden" },
	        //{ type: "preview", minSize:900, style: pstyle, content: $("#interface-maps")[0] },
	        { type: 'right', size: 240, minSize:190, resizable: true, style: pstyle, content: $("#interface-elements")[0] }
	    ],
        onRender: function(e){
            //console.log(this);
            //console.log(this.box);
            // Maps container tabs

            $("#interface-maps .maps-container").tabs({
                active: false
            }).find( ".ui-tabs-nav" ).sortable({
		      axis: "x",
		      cancel: ".add-tab",
		      stop: function() {
		        $("#interface-maps .maps-container").tabs( "refresh" );
		      },
		      update: function(e,ui){
		      	var $addTab = $(this).find(".add-tab");
		      	var newIndex = $(this).find("li").index(ui.item);
		      	$(this).append($addTab);
		      	
		      	var oNode = ui.item.data("eveManagerNode");

				oNode.shiftNode(newIndex);
				/*console.log(ui);
				console.log(ui.item.data());
				console.log(ui.item.data("eveManagerNode"));
				console.error(newIndex);*/
				
		    	}
		    });

            $("#mapImageLoad").button();
        }/*,
        onRefresh: function(e){
            if(this.box == undefined || this.box == null){
                return;
            }

            var $box = $(this.box);
            var $w2uiPanels = $box.find(".w2ui-panel");

            $w2uiPanels.addClass("ui-widget-content");
        }*/
    });

    //mylists
    $('#lists').w2layout({
        name: 'lists',
        panels: [
            { type: "main", minSize:1050, style: pstyle, content: $("#mylists")[0], overflow: "scroll" },
            { type: 'right', size: 240, minSize:190, resizable: true, style: pstyle, content: $("#lists-elements")[0] }
        ]
    });

    /* Create resizable layout for Components tab */
	$('#createcomponents').w2layout({
        name: 'createcomponents',
        panels: [
			/*{ type: 'top', size: 50, resizable: false, style: pstyle, content: "" },*/
            { type: 'left', size: 300, minSize:230, height:600, resizable: true, style: pstyle, content: $("#componentslibrary")[0], overflow: "hidden" },
            { type: 'main', minSize:400, style: pstyle, content: $("#mycomponents")[0], overflow: "hidden" },
            { type: 'right', size: 400, minSize:250, resizable: true, style: pstyle, content: $("#componentproperties")[0], overflow: "hidden" }
        ],
		onRender: function(e){
			//Component library accordion
            //console.log("render");
			$("#library").accordion($.extend(false,basicAccordion,{
			    create:function(e){
    				var $this = $(this);
    				
    				//Set all components here
    				var $components = $this.find("div:not(.components-all) li");
    				
    				//Fill all components
    				$(".components-all ul").html($components.clone());


    				$this.find("li").draggable({
    					appendTo: "body",
    					revert: "invalid",
    					revertDuration: false,
    					//containment: "body",
    					//containment: "#componentscontainer",
    					//connectToSortable: "#componentscontainer, #componentscontainer ul",
                        //connectToSortable: "#componentscontainer",

                        // Questa riga rallenta un cifrazza
    				    //connectToSortable: "#componentscontainer, #componentscontainer [eve-manager-component='group'] > ul",
    				    // Questa riga rallenta un cifrazza

    				    //connectToSortable: "#componentscontainer",
    					helper: "clone",
                        scroll: false,
    					start: function(e,ui){
                          //  console.log("start drag");

    						//$("#componentscontainer > div").accordion("option","event","mouseover");
    						//console.debug("Change accordion event in 'mouseover'");
    					},
    					stop: function (e, ui) {
                            // Elemento draggato nella finestra dei componenti
    					    var $elem = $(document.elementFromPoint(e.clientX, e.clientY));
    					    var $div = $elem.closest("div");
    					    var id = $div.attr('id');
    					    var oParent = eveManager.getComponentsRoot();
    					    if (id != "mycomponents") {
    					        oParent = undefined;
    					        var data = $div.data();
    					        if (data != undefined) {
    					            oParent = data.eveManagerNode;
    					        }
    					    }

    					    if (oParent == undefined) {
                                // No right zone where to add the component
    					        return;
    					    }

    					    var strType = e.target.attributes["eve-manager-component"].value;
    					    var oComponent = application.addComponent({ type: strType }, oParent);
    					    application.selectComponent(oComponent);


    					    //console.log(oParent);
    					    //alert(e.target);
    					    // var $parent = $("#"+ oParent.getData().id); 
    					    //alert("asdasdas");
    					    //application.addComponent({ type: "info", name: "info 2" });

                           // console.log("stop drag");

                            //console.warn(e);
                            //console.warn(ui);
    						//console.debug("Change accordion event in 'click'");
    						//$("#componentscontainer > div").accordion("option","event","click");
    					},
    					zIndex: 1000
    				});
				}
			}));

		}
    });

    $('#gateways').w2layout({
        name: 'gateways',
        panels: [
            { type: "main", style: pstyle, minSize:400, content: $("#mygateways")[0], overflow: "hidden" },
            { type: 'right', size: 300, minSize:300, resizable: true, style: pstyle, content: $("#gateway-properties")[0], overflow: "hidden" }
        ]
    });

    $('#relations').w2layout({
        name: 'relations',
        panels: [
            { type: "main", minSize:900, style: pstyle, content: $("#myrelations")[0], overflow: "hidden" },
            { type: 'right', size: 240, minSize:190, resizable: true, style: pstyle, content: $("#relations-components")[0], overflow: "hidden" }
        ],
        onRender: function(e){
            $("#myrelations .relations-container").sortable({ axis: "y" });
        }
    });
	
	//Tabs
	//$("#tabs").tabs( {active: 1} );
    $("#tabs").tabs({
        activate:function(event,ui){
            //console.log(ui.index);
            var oldTab=ui.oldTab.text();
            var newTab=ui.newTab.text();

            var oldTabIndex=ui.oldTab.index();
            var newTabIndex=ui.newTab.index();

            var $list;
            var drag;
            if(oldTabIndex==1)  $list=jQuery("#mycomponents #componentscontainer").detach();
            if(oldTabIndex==3){
             //   drag=$("#interface-components #componentscontainer").draggable("instance");
                $list=jQuery("#interface-components #componentscontainer").detach();
            }
            if(oldTabIndex==2)  $list=jQuery("#lists-components #componentscontainer").detach();
            if(oldTabIndex==0)  $list=jQuery("#mycomponents #componentscontainer").detach();
           // $("#mycomponents .li ,#lists-components li, #interface-elements li, #interface-components li").draggable();
           // $("#mycomponents .li ,#lists-components li, #interface-elements li, #interface-components li").draggable("destroy");


            if(newTabIndex==3){
                $list.appendTo("#interface-components");
                $list.find("[eve-manager-component='label']").show();
                $list.find(".extra").hide();
                $.publish("/view/interface/resize");
                $("#componentscontainer li").draggable({
                    appendTo: "body",
                    helper: function (e) {
                        return $(e.currentTarget).clone(true);
                    },
                    /*
                     revert: "invalid",
                     revertDuration: false,
                     connectToSortable: "#componentscontainer",
                     //helper: "clone",

                     */zIndex: 1000
                });

                var activated= $('#interface-maps .maps-container').tabs("option", "active");
              //  console.log("MAPS   ");
              //  console.log(activated);

                $('#interface-maps .maps-container').tabs({ active: -1  });
                $('#interface-maps .maps-container').tabs({ active: activated  });

            }

            if(newTabIndex==2){
                //console.log("Classic Interface selected");
                $list.appendTo("#lists-components");
                $list.find("[eve-manager-component='label']").hide();
                $list.find(".extra").hide();
                $list.find(".eve-managerui-onlyMap").hide();
                $.publish("/view/lists/resize");



                var strConnectWith = "#mylists .level";

                var strInterfaceElementSelector = "#componentscontainer li";
                $(strInterfaceElementSelector).draggable({
                    appendTo: "body",
                    containment: "body",
                    revert: "invalid",
                    revertDuration: false,
                    connectToSortable: strConnectWith,
                    //helper: "clone",
                    helper: function(e){ return $(e.currentTarget).clone(true); },
                    zIndex: 1000
                });


            }

            if(newTabIndex==1 ) {
                $list.appendTo("#mycomponents");
              //  $("#interface-components #componentscontainer").draggable=drag;
                $list.find("[eve-manager-component='label']").hide();
                $list.find(".extra").hide();
                $list.find(".eve-managerui-onlyMap").show();

                try{$("#componentscontainer li").draggable("destroy");}catch(ex){};



/*

try{
    $("#componentscontainer li").draggable("destroy");

}
                catch(ex){}
                $("#componentscontainer li").draggable({
                    appendTo: "body",
                    containment: "body",
                    revert: "invalid",
                    revertDuration: false,
                    connectToSortable: "#componentscontainer",
                    /*  helper: function(e){
                     return $(e.currentTarget).clone(true); },
                     */
                /*    zIndex: 1000
                });*/
                $.publish("/view/components/resize");


            }
         //   if(e.target.text=="Relations")  $.publish("/view/relations/resize");

            if(newTabIndex==0)  {
                $list.appendTo("#mycomponents");
                $.publish("/view/gateways/resize");
            }



        }
    });
	
	//Interface elements
	$("#interface-elements, #lists-elements").tabs({
        heightStyle: "fill",
		create: function(e,ui){
			var $this = $(this);


            var $iconsSet = $this.find("#interface-icons, #lists-icons");
			
			//Create icons accordion
			$iconsSet.accordion($.extend(false,basicAccordion,{
				active: true
				/*create: function(e,ui){
					var $this = $(this);
					var $allIcons = $this.find(".icons-all ul");
					var $getIcons = $this.find("div:not(.icons-all) li");
					
					//Create all icons
					//$allIcons.append($getIcons.clone(true));
				}*/
			}));
		},
        activate: function( event, ui ) {

            var tabIndex=ui.newTab.index().toString();
            if (tabIndex=="1") // mycomponents
            {
   /*             console.log(tabIndex);
                var strConnectWith = "#myinterface .level, #mylists .level,#interface-maps .maps-container .viewer";

                var strInterfaceElementSelector = "#lists-components #interface-elements #interface-components li";
                $(strInterfaceElementSelector).draggable({
                    appendTo: "body",
                    containment: "body",
                    revert: "invalid",
                    revertDuration: false,
                    connectToSortable: strConnectWith,
                    //helper: "clone",
                    helper: function(e){ return $(e.currentTarget).clone(true); },
                    zIndex: 1000
                });
                $.publish("/view/interface/resize");*/
            }

        }

	});

/*
	// Maps container tabs
	$("#interface-maps .maps-container").tabs({
        activate: function( event, ui ) {
            console.log("acive");

        },

        load: function( event, ui ) {
            console.log("load");

        }

    });

*/

	//Sortable
	$("#myinterface .level, #mylists .level").sortable($.extend(false,basicSortable,{
		//Set selector
        connectWith: "#interface-elements ul",
		activeClass: "accept",
		scroll: true,
		axis: false,
		cancel: ".drop-target",
		placeholder: "target",
		update: function(e,ui){
			var $this = $(this);
			var $dropTarget = $this.find(".drop-target");
			
			//Put drop target always at the end 
			$this.append($dropTarget);
		}
	}));
    
	//Component sortable
	$("#componentscontainer").sortable($.extend(false,basicSortable,{
        //tolerance: "pointer",
        //cancel: ".extra, [eve-manager-component='group']"
        distance: 5,
	    cancel: ".extra"
    }));




    //Gateways sortable
	$("#mygateways .gateways").sortable({
	    scroll: false,
	    forcePlaceholderSize: true,
	    cancel: "#mygateways [special]"
	});



	//Edit tab
	/*$("#edit_tab").dialog({
		height: 180,
		minHeight: 150,
		width: 300,
		minWidth: 300,
		autoOpen: false,
		title: _D("Edit Tab"),
		closeText: _D(),
		modal: true,
		create: function(e,ui){
			var $this = $(this);
			$this.find("button").button();
			$this.find(".cancel").on("click",function(e){
				$this.dialog("close");
			});
		},
		close: function(e,ui){
			var $this = $(this);
			$this.find("input[type='text']").val("");
			$this.find(".remove").button("enable");
		},
		open: function(e,ui){
			var $this = $(this);
			$this.find(".name").focus();
			$this.find(".name")[0].select();
		}
	});*/
	
	/** System info dialog box */
	$("#system-info").dialog({
	    height: "auto",
        width: "auto",
        autoOpen: false,
        title: _D("About"),
        modal: true,
        resizable: false
	});

    /** Vimar import project */
    $("#vimarProject").dialog({
        autoOpen: false,
        title: _D("Vimar By Me import project"),
        modal: true,
        resizable: false,
        create: function(e,ui){
            $(this).find("button").button();
        }
    });

	
	/** Icons Picker dialog box */
    $("#icons-picker").dialog({
        height: 400,
        //height: "auto",
        width: 500,
        //width: "auto",
        autoOpen: false,
        modal: true,
        open: function(e,ui){
            var $this = $(this);
            $this.parent().find(".ui-widget-header").hide();
            $this.parent().css("border-radius","0");
            $(".ui-widget-overlay").bind("click",function(){
                $this.dialog("close");
            });
        },
        close: function(e,ui){
            var $this = $(this);
            $this.find("li").unbind("click");
            $(".ui-widget-overlay").unbind("click");
        }
    });
    
    /** Multi Calendar dialog box */
   $("#calendar-dialog").dialog({
        height: "auto",
        width: "auto",
        resizable: false,
        //draggable: false,
        autoOpen: false,
        title: _D("Calendars"),
        modal: true,
        create: function(e){
            var $this = $(this);
            
            //Max Date settings 
            var FUTURE_YEARS = 10;
            var _maxDate = new Date((new Date()).getFullYear() + FUTURE_YEARS,11,31);
            
            //$componentProperties.find(".calendar").multiDatesPicker({
            $this.find(".calendar").multiDatesPicker({
                beforeShowDay: function(date){
                    //console.log(date);
                    return [ true, "selected" ];
                },
                dateFormat: "dd/mm/yy",
                minDate: "today",
                maxDate: _maxDate,
                numberOfMonths: [3,4],
                autoselectRange: false,
                stepMonths: 12
            });
        }
    });

    /** Timed thermostat picker */
    $("#timed-termostat-settings").dialog({
        height: "auto",
        width: "auto",
        resizable: false,
        autoOpen: false,
        title: _D("Timed Thermostat"),
        modal: true,
        create: function(e,ui){
            var $this = $(this);

            $this.find("button").button();
            //$this.find("input").button();
            $this.find(".week-days").buttonset();

            //On actions click
            $this.find(".actions button[type='submit']").on("click",function(e){ $this.dialog("close"); });
            $this.find(".actions button[type='button']").on("click",function(e){ $this.dialog("close"); });

            //On week click
            $this.find(".edit").on("click",function(e){
                $this.find(".slider").slider( "enable" );
                $this.find(".start-edit").show();
                $this.find("input[type='radio']").attr("type","checkbox");
                $(this).hide();
            });

            //
            $this.find(".start-edit").on("mousedown",function(e){
                $this.find(".slider").bind("mousemove",function(e){
               //     console.log("ciao1");
                    $(this).data("uiSlider")._mouseCapture(e);
                }).bind("mouseout",function(e){
                 //   console.log("ciao2");
                    $(this).data("uiSlider")._mouseStop(e);
                });
            });

            //On week click
            $this.find(".week-days input").on("click",function(e){
                var day = $(this).attr("id");
                var oData = $this.data("week-program");
                var aTemperatures = new Array();

                if(day.indexOf("monday") != -1){ aTemperatures = oData.monday; }
                else if(day.indexOf("tuesday") != -1){ aTemperatures = oData.tuesday; }
                else if(day.indexOf("wednesday") != -1){ aTemperatures = oData.wednesday; }
                else if(day.indexOf("thursday") != -1){ aTemperatures = oData.thursday; }
                else if(day.indexOf("friday") != -1){ aTemperatures = oData.friday; }
                else if(day.indexOf("saturday") != -1){ aTemperatures = oData.saturday; }
                else if(day.indexOf("sunday") != -1){ aTemperatures = oData.sunday; }

                for(var i=0; i<aTemperatures.length; ++i){
                    var $slider = $this.find(".slider").eq(i);
                    $slider.slider("option", "value", aTemperatures[i]);
                    $slider.parent().find(".degrees").text(aTemperatures[i]);
                }
            });

            //Max Date settings
            //var FUTURE_YEARS = 10;
            //var _maxDate = new Date((new Date()).getFullYear() + FUTURE_YEARS,11,31);

            $this.find(".slider").slider({
                orientation: "vertical",
                max: 35,
                min: 5,
                slide: function(e,ui){
                    $(this).parent().find(".degrees").text(ui.value);
                },
                change: function(e,ui){
                    var $checked = $this.find(".week-days input:checked");

                    if($checked.length < 1){ return; }

                    var oData = $this.data("week-program");
                    var index = $($this.find(".slider")).index( this );
                    $(this).parent().find(".degrees").text(ui.value);

                    for(var i=0; i<$checked.length; ++i){
                        var day = $($checked[i]).attr("id");
                        //var aTemperatures = new Array();
                        //console.error(day);

                        if(day.indexOf("monday") != -1){ oData.monday[index] = parseInt(ui.value,10); }
                        else if(day.indexOf("tuesday") != -1){ oData.tuesday[index] = parseInt(ui.value,10); }
                        else if(day.indexOf("wednesday") != -1){ oData.wednesday[index] = parseInt(ui.value,10); }
                        else if(day.indexOf("thursday") != -1){ oData.thursday[index] = parseInt(ui.value,10); }
                        else if(day.indexOf("friday") != -1){ oData.friday[index] = parseInt(ui.value,10); }
                        else if(day.indexOf("saturday") != -1){ oData.saturday[index] = parseInt(ui.value,10); }
                        else if(day.indexOf("sunday") != -1){ oData.sunday[index] = parseInt(ui.value,10); }

                        //aTemperatures[index] = ui.value;
                        //console.error(oData);
                    }
                }
            });
        },
        open: function(e,ui){
            var $this = $(this);
            $this.find(".slider").slider( "disable" );
            $this.find(".start-edit").hide();
            $this.find("input[type='checkbox']").attr("type","radio");
            $this.find(".edit").show();

            $(document).on("mouseup.timedtermostat",function(e){

                $this.find(".slider").unbind("mousemove").unbind("mouseout");
            });

            $this.find(".week-days input").removeProp("checked").eq(0).click();
        },
        close: function(e,ui){
            $(document).off("mouseup.timedtermostat");
        }
    });

    /** Plugins */
    $("#plugins").dialog({
        height: "auto",
        maxHeight: 500,
        width: 480,
        resizable: false,
        autoOpen: false,
        title: _D("Plugins"),
        modal: true,
        open: function(e,ui){
            var $this = $(this);
            var $list = $this.find("#plugins-list");
            var aDownloadsList = QT.fileList(QT.applicationPath()+"/data/plugins/downloads/");
            //console.log(aDownloadsList);

            $this.find("p img").show();            
			
			var connectedToInternet = eveDesk.isIleviaOnline();
			console.log('Connected to internet: ' + connectedToInternet);
			
			if(connectedToInternet == 'false' && (aDownloadsList == undefined || aDownloadsList.length == 0)) {
				$this.find("p img").hide();
				$('#plugins-updates-li').css("display", "none");
				$("#plugins-span-update-to-eve").text(_D('Please connect to the internet'));
				$("#plugins-start-eve-update").hide();
			} else {
				$("#plugins-start-local-update").button();
				$('#plugins-updates-li').css("display", "none");	
				$("#plugins-start-eve-update").show();		
				$("#plugins-start-eve-update").button();
				$("#plugins-start-eve-update").focus();
				$("#plugins-span-update-to-eve").text(_D("Install selected plugin(s) to EVE"));
			}
			
			//eve logic as first element
			aDownloadsList=sortLocalPluginsFileName(aDownloadsList);
			

            for(var i=0; i<aDownloadsList.length; ++i){
                
                //hide icons
                if(aDownloadsList[i].name.indexOf(".json") == -1)
                	continue;
                
               	//hide evelogic
	           // if(aDownloadsList[i].name == 'evelogic.json')
	           // 	continue;
                	
                var $li = getPluginElementHtml();          
                var json = JSON.parse( QT.readFile("../plugins/downloads/"+aDownloadsList[i].name) );

                //var $download = $li.find(".download");
                //var $install = $li.find(".install");

                $li.attr("eve-manager-plugin",json.id);
                $li.attr("title",json.description);
                if(connectedToInternet == "true") {
                	$li.find(".icon").attr("src",json.iconurl);
                } else {
                	$li.find(".icon").attr("src","../plugins/downloads/"+json.iconurl.substring(json.iconurl.lastIndexOf("/")+1));
                }

                //$download.attr("eve-manager-url",json.url);

                $li.find(".name").text(json.name);
                $li.find(".version").text(json.ver);
                $li.find(".date").text(json.data);

                //$li.find(".install").css('visibility','visible').attr("eve-manager-url","../plugins/"+json.id+".tar.gz");
                $li.find(".upload-plugin").css('visibility','visible').attr("eve-manager-url","../plugins/"+json.id+".tar.gz");
                
                //evelogics is the first and must always be checked
                if(i == 0)
                	$li.find(".upload-plugin").prop('checked', true);
                	
                $li.find(".remove").css('visibility','visible');

                $li.data({ "pluginInfo": json });
				
				var uploadProgress =$("<span id='"+json.id+"-upload-progress'></span>");
				uploadProgress.addClass("progress");
				$li.append(uploadProgress);

                $list.append($li);
            }

            //TODO TEMPORANEO
            $this.find(".config").css("visibility","visible");        //TODO TEMPORANEO
            //TODO TEMPORANEO
			
			if(connectedToInternet == "true") {
				

	            $.ajax({
	                url: "http://www.ilevia.com/eve/plugins20160117/list.php",
	                dataType: "jsonp",
	                cache : false,
	                complete: function(){
	                    $this.find("p img").hide();
	                },

	                success: function(json){
	                	        	
	                	var updatesFound = 0;
	                	//list of local files
	                	var aDownloadsList = QT.fileList(QT.applicationPath()+"/data/plugins/downloads/");
	                	
	                	var localPluginNumber = 0;
	                	for(var i=0; i<aDownloadsList.length; ++i){
	               			if(aDownloadsList[i].name.indexOf(".json") == -1)
			                	continue;
			                else
			                	localPluginNumber++;
	                	}
	                	
	                	//check if there is a new plugin
	            		if(localPluginNumber < json.length) {
	            			updatesFound = json.length - localPluginNumber;
	            			console.log(updatesFound + " new plugin(s) found");
	            		}
	            
	                	//check plugin version
				        for(var i=0; i<aDownloadsList.length; ++i){
			                if(aDownloadsList[i].name.indexOf(".json") == -1)
			                	continue;
			                	
				            var localJson = JSON.parse( QT.readFile("../plugins/downloads/"+aDownloadsList[i].name));			            			                            
                			            
				            for(var j=0; j<json.length; ++j){
	                			if(localJson.id.toLowerCase().trim() == json[j].id.toLowerCase().trim()) {
	                				if(parseFloat(localJson.ver) < parseFloat(json[j].ver)) {
	                					console.log("Plugin " + localJson.name + " needs to be updated from version " + localJson.ver + " to version " + json[j].ver);
	                					updatesFound++;
	                				}
	                			}          		
	                		}						
				        }
				       
				       //console.log(updatesFound);
				       
						if(updatesFound > 0){
							$('#plugins-updates-li').css("display", "block");
							$("#plugins-span-update-found").text(updatesFound + _D(" new update(s) found"));
							$("#plugins-start-local-update").focus();
							//$("#plugins-start-local-update").button();
							
							//$("#plugins-span-update-to-eve").text(_D("Install selected plugin(s) to Eve"));
							//$("#plugins-start-eve-update").button();
						} /*else {
							$('#plugins-updates-li').css("display", "none");
							
						$("#plugins-span-update-found").text(_D("No update(s) found"));
							$("#plugins-start-local-update").button();
							
							$("#plugins-span-update-to-eve").text(_D("Install selected plugin(s) to Eve"));
							$("#plugins-start-eve-update").button();				
						} */
				                     	
	                	
	                    for(var i=0; i<json.length; ++i){
	                    	
	                    	//hide evelogic
	                    	//if(json[i].id == 'evelogic')
	                    	//	continue;
	                    	
	                        var $li = $list.find("[eve-manager-plugin='"+json[i].id+"']");
	

	                        if($li.length < 1){
	                            $li = getPluginElementHtml();
	

	                          //  var $download = $li.find(".download");
	                       //     var $install = $li.find(".install");
	

	                            $li.attr("eve-manager-plugin",json[i].id);
	                            $li.attr("title",json[i].description);
	                            $li.find(".icon").attr("src",json[i].iconurl);
	                            
								//console.log(json[i].iconurl);
								

	                            //$download.attr("eve-manager-url",json[i].url);
	

	                            $li.find(".name").text(json[i].name);
	                            $li.find(".version").text(json[i].ver);
	                            $li.find(".date").text( json[i].data );
	

	                            $li.data({ "pluginInfo": json[i] });
	
								var uploadProgress =$("<span id='"+json[i].id+"-upload-progress'></span>");
								uploadProgress.addClass("progress");
								$li.append(uploadProgress);
	

	                            $list.append($li);
	                        }
	


	                        //$li.find(".download").css('visibility','visible').attr("eve-manager-url",json[i].url);
	                        //$li.find(".upload-plugin").css('visibility','visible').attr("eve-manager-url",json[i].url);
	                        $li.data({ "pluginInfo": $.extend(true,$li.data("pluginInfo"),json[i]) });
	                        continue;
	


	                   /*     var $li = $("<li></li>");
	                        var $name = $("<span></span>");
	                        var $icon = $("<img />");
	                        var $version = $("<span></span>");
	                        var $date = $("<span></span>");
	

	                        //var $info = $("<span></span>");
	                        var $download = $("<span></span>");
	                        var $install = $("<span></span>");
	                        var $config = $("<span></span>");
	

	                        //console.log(json[i]);
	

	                        $li.attr("eve-manager-plugin",json[i].id);
	                        $li.attr("title",json[i].description);
	                        $download.attr("eve-manager-url",json[i].url);
	                        $icon.attr("src",json[i].iconurl);
	                        $download.attr("title",_D("download/update"));
	                        $install.attr("title",_D("install"));
	

	                        $config.attr("title",_D("configure"));
	

	                        $name.text(json[i].name);
	                        $version.text(json[i].ver);
	                        //$date.text(new Date( json[i].data) );
	                        $date.text( json[i].data );
	

	                        $name.addClass("name");
	                        $version.addClass("version");
	                        $icon.addClass("icon");
	                        $date.addClass("date");
	                        $download.addClass("download").addClass("ui-icon").addClass("ui-icon-arrowthickstop-1-s");
	                        $install.addClass("install").addClass("ui-icon").addClass("ui-icon-transferthick-e-w");
	                        $config.addClass("config").addClass("ui-icon").addClass("ui-icon-gear");
	

	                        $li.append($icon);
	                        $li.append($name);
	                        $li.append($version);
	                        //$li.append($date);
	

	                        $li.append($download);
	                        $li.append($install);
	                        $li.append($config);
	

	                        $li.data({ "pluginInfo": json[i] });
	

	                        $list.append($li);*/
	

	                        //Check downloaded plugins
	                    }
	                    
	                    $.event.trigger({
							type: "PluginsWindowLoaded",
							message: "Plugins Window Loaded",
							time: new Date()
						});
	                    
	                },


	                error: function(jqXHR,textStatus,errorThrown){
	                    console.error(jqXHR);
	                     /* console.error(textStatus);
	                    console.error(errorThrown); */
	

	                    $list.append($("<li class='ui-state-error'>"+ textStatus +"</li>"));
	                }
	            });
            } else {
            	$this.find("p img").hide();
            }


        },
        close: function(e,ui){
            $(this).find("#plugins-list").empty();
            //$(this).dialog("destroy").remove();
			//delete window["plugins/update"];

        }
    });

    /** Plugins */
    $("#preferences").dialog({
        height: "auto",
        maxHeight: 500,
        width: "auto",
        resizable: false,
        autoOpen: false,
        title: _D("Preferences"),
        modal: true,
        create: function(e,ui){
            var $this = $(this);

            $this.find("button").button();
            $this.find(".explore").button("option","icons",{ primary: "ui-icon-folder-open" }).button("option","text",false);

            $this.on("click","button[type='submit']",function(e){
                presenter.preferences.setParameter("projectsDir",$this.find(".dir").val());
                $this.dialog("close");
            });

            $this.on("click",".cancel",function(e){
                $this.dialog("close");
            });

            /*alert($this.find("submit").length);
            $this.find("submit").click(function(e){
                alert();
                $this.dialog("close");
            });*/
        },
        open: function(e,ui){
            var $this = $(this);

            $this.find(".dir").val(presenter.preferences.getParameter("projectsDir"));
        },
        close: function(e,ui){
            var $this = $(this);

            //$this.find(".dir");

        }
    });

    /** Components info */
    $("#components-info").dialog({
        //height: "auto",
        minHeight: 500,
        //width: "auto",
        minWidth: 870,
        resizable: false,
        autoOpen: false,
        title: _D("Components list"),
        modal: true,
        open: function(e,ui){
            var $this = $(this);

            w2ui['components-info'].clear();

            //Declare recursive function for decode components
            function componentsSerialize(oNode){
                var oSerialized = oNode.encodeJSON();

                if(oSerialized.special == undefined && oSerialized.type != "group"){

                    oSerialized.recid = oSerialized.UId;
                    oSerialized.protocol = application.getGatewayByUid( oSerialized.gateway ).getData().getProtocol();

                    //Push serialization object
                    /*
                    setTimeout(function(){
                        w2ui['components-info'].add(oSerialized);
                    },1);
                    */
                    w2ui['components-info'].add(oSerialized);
                }

                for(var i=0;i<oNode.children.length;++i){
                    componentsSerialize(oNode.children[i]);
                }
            };

            var oComponentsRoot = model["instance"].getComponentsRoot();
            for(var i=0;i<oComponentsRoot.children.length;++i){
                componentsSerialize(oComponentsRoot.children[i]);
            }
        },
        close: function(e,ui){
            var $this = $(this);

            w2ui['components-info'].clear();
        },
        create: function(e,ui){
            var $this = $(this);

            $this.find("button").button();

            $this.find(".grid").w2grid({
                name: 'components-info',
                show: {
                    toolbar: true,
                    footer: true,
                    toolbarReload: false
                },
                multiSearch : false,
                multiSelect : false,
                searches: [
                    { field: 'UId', caption: 'UID', type: 'text' },
                    { field: 'name', caption: 'Name', type: 'text' }
                ],
                sortData: [ { field: 'protocol', direction: 'asc' } ],
                columns: [
                    { field: 'UId', caption: 'UID', size: '40px', sortable: true },
                    { field: 'name', caption: _D('Component Name'), size: '400px', sortable: true },
                    { field: 'type', caption: _D('Type'), size: '200px', sortable: true },
                    { field: 'protocol', caption: _D('Protocol'), size: '200px', sortable: true }
                ]
            });
        }
    });

    /** Draggable cursor pointer
    $("body").on("dragstart",".ui-draggable",function(e){
        console.log("Drag start");
        
        //document.body.style.cursor = "url('./assets/cursor/cursor.png')";
        //console.log(document.body.style.cursor);
        
        $("body").css("cursor","url('./assets/cursor/cursor.png'), auto");
    });
    
    $("body").on("dragstop",".ui-draggable",function(e){
        console.log("Drag stop");
        
        document.body.style.cursor = "default";
        
        //$("body").css("cursor","inherit");
    }); */
});